#include <signal.h>
#include <stdbool.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

bool done = false;

void handler(int signo)
{
    if (signo == SIGALRM)
    {
        printf("alarm delivered\n");
    }
}

int main()
{
    sigset_t mask;
    sigset_t old_mask;

    if (sigemptyset(&mask) == -1)
    {
        perror("sigemptyset failed, idk how but it did");
        exit(EXIT_FAILURE);
    }

    if (sigaddset(&mask, SIGINT) == -1)
    {
        perror("sigaddset failed, idk how but it did");
        exit(EXIT_FAILURE);
    }
    struct sigaction sa;
    sa.sa_handler = handler;
    sa.sa_flags = SA_RESTART;          // No special flags necessary.
    sigemptyset(&sa.sa_mask); // Do not block additional signals during handler execution
                              // we need this so that the trash in sa, isn't used to set the signal mask.

    // not error checking cause I am too tired
    sigaction(SIGALRM, &sa, NULL); 
    alarm(5);

    sigsuspend(&mask); //at this point, what are we blocking??

    if (sigprocmask(SIG_UNBLOCK, &mask, &old_mask) == -1)
    {
        perror("sigprocmask failed, idk how but it did");
        exit(EXIT_FAILURE);
    }

    // could use a while true loop
    // while (true) { }

    if (sigemptyset(&mask) == -1)
    {
        perror("sigemptyset failed, idk how but it did");
        exit(EXIT_FAILURE);
    }
    
    sigsuspend(&mask);

    return EXIT_SUCCESS;
}
